// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef NETWORK_INTERFACE_APB_WRAPPER_HH
#define NETWORK_INTERFACE_APB_WRAPPER_HH

#include <cstddef>
#include <stdint.h>
#include "network_interface.hpp"

class network_interface_apb_wrapper
{

public:

    uint32_t pwdata_old;
    bool pwrite_old;
    bool penable_old;
    bool psel_old;
    uint32_t paddr_old;
    bool presetn_old;
    bool pclk_old;
    struct network_interface_apb_wrapper_iostruct{
        bool * pclk;
        bool * presetn;
        uint32_t * paddr;
        bool * psel;
        bool * penable;
        bool * pwrite;
        uint32_t * pwdata;
        bool * pready;
        uint32_t * prdata;

        network_interface_apb_wrapper_iostruct():
            pclk(nullptr),
            presetn(nullptr),
            paddr(nullptr),
            psel(nullptr),
            penable(nullptr),
            pwrite(nullptr),
            pwdata(nullptr),
            pready(nullptr),
            prdata(nullptr)
        {}

        network_interface_apb_wrapper_iostruct( bool * pclk_4, bool * presetn_4,
             uint32_t * paddr_4, bool * psel_4, bool * penable_4, bool * pwrite_4,
             uint32_t * pwdata_4, bool * pready_4, uint32_t * prdata_4 ):
            pclk(pclk_4),
            presetn(presetn_4),
            paddr(paddr_4),
            psel(psel_4),
            penable(penable_4),
            pwrite(pwrite_4),
            pwdata(pwdata_4),
            pready(pready_4),
            prdata(prdata_4)
        {}

        ~network_interface_apb_wrapper_iostruct()
        {}

        bool operator == (const network_interface_apb_wrapper_iostruct & other)
             const
        {
            if (pclk != other.pclk) return false;
            if (presetn != other.presetn) return false;
            if (paddr != other.paddr) return false;
            if (psel != other.psel) return false;
            if (penable != other.penable) return false;
            if (pwrite != other.pwrite) return false;
            if (pwdata != other.pwdata) return false;
            if (pready != other.pready) return false;
            if (prdata != other.prdata) return false;
            return true;
        }
    };
    network_interface_apb_wrapper_iostruct hif_a2t_data;
    bool clk;
    bool reset;
    bool mode;
    bool rx_data_ready;
    uint32_t rx_data;
    bool tx_data_ready;
    uint32_t tx_data;
    bool tx_data_done;
    network_interface_apb_wrapper();


    ~network_interface_apb_wrapper();


    network_interface network_interface_0;
    bool clk_new;
    bool reset_new;
    bool mode_new;
    bool rx_data_ready_new;
    uint32_t rx_data_new;
    bool tx_data_ready_new;
    uint32_t tx_data_new;
    bool tx_data_done_new;
    bool process_in_queue;
    bool flag_globact_process_11_executed;
    bool flag_pclk;
    bool flag_globact_process_12_executed;
    bool flag_presetn;
    bool flag_globact_process_13_executed;
    bool flag_pwrite;
    bool flag_rx_data_ready;
    bool flag_tx_data_done;
    bool flag_rx_data;
    bool flag_globact_process_16_executed;
    bool flag_penable;
    bool flag_globact_process_17_executed;
    bool flag_pwdata;

    void perform_bindings();


    void globact_process_11();


    void globact_process_12();


    void globact_process_13();


    void globact_process_14();


    void globact_process_15();


    void globact_process_16();


    void globact_process_17();


    void update_input_queue( bool synch_phase = true );


    void update_event_queue();


    void flag_elaboration();


    void start_of_simulation();


    void initialize();


private:

    network_interface_apb_wrapper( const network_interface_apb_wrapper & );
    const network_interface_apb_wrapper& operator= ( const network_interface_apb_wrapper
         & );


};


#endif

